module BigMarkerClient
  module Models
    class Attendee < Base
      attr_accessor :id, :bmid, :conference_id, :email, :first_name, :last_name, :edited_in_room_display_name,
                    :custom_fields, :entered_at, :leaved_at, :total_duration, :engaged_duration, :attendance_monitor,
                    :survey_results, :time_zone, :country,
                    :chats_count, :qas_count, :polls_count, :polls, :questions, :handouts, :browser_name,
                    :browser_version, :device_name
      attr_reader :view_handout, :download_handout

      def download_handout=(handout_array)
        @download_handout = if handout_array.nil? || !handout_array.is_a?(Array) || handout_array.empty?
                              []
                            else
                              handout_array.map { |handout_hash| Handout.new(handout_hash) }
                            end
      end

      def view_handout=(handout_array)
        @view_handout = if handout_array.nil? || !handout_array.is_a?(Array) || handout_array.empty?
                          []
                        else
                          handout_array.map { |handout_hash| Handout.new(handout_hash) }
                        end
      end
    end
  end
end
